//+------------------------------------------------------------------+
//|                                            MacdACSignals.mq4.mq4 |
//|                                              Tonkonog G.S., 2009 |
//|                                    hurricane79@yandex.ru         |
//+------------------------------------------------------------------+
#property copyright "Tonkonog G.S., 2009"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Yellow
//---- input parameters

extern bool Pattern_1=true;
extern bool Pattern_2=true;
extern bool Pattern_3=true;
extern bool CheckSignal=true;
extern bool CheckZero=true;
extern int  WhaitForBars=5; //   0
extern int  OsMAFastPeriod=12;
extern int  OsMASlowPeriod=26;
extern int  OsMASignalPeriod=9;
extern int  OsMAPrice=0; 
extern int  MACDFastPeriod=12;
extern int  MACDSlowPeriod=26;
extern int  MACDSignalPeriod=9;
extern int  MACDPrice=0;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double After0CrosBarCnt[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators

   IndicatorBuffers(3);

   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,236);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,238);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexEmptyValue(1,0.0);
   
   SetIndexBuffer(2,After0CrosBarCnt);
   SetIndexEmptyValue(2,0.0);

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);  
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){
   double MacdCurrent,MacdPrevious,SignalCurrent,SignalPrevious,AC1,AC2,AC3,AC4,AC5;
   int limit=Bars-IndicatorCounted()-1;

   for(int i=limit;i>=0;i--){
    
    After0CrosBarCnt[i]=After0CrosBarCnt[i+1];
    
    ExtMapBuffer1[i]=EMPTY_VALUE;
    ExtMapBuffer2[i]=EMPTY_VALUE;
    
    MacdCurrent=iMACD(NULL,0,MACDFastPeriod,MACDSlowPeriod,OsMASignalPeriod,OsMAPrice,MODE_MAIN,i);
    MacdPrevious=iMACD(NULL,0,MACDFastPeriod,MACDSlowPeriod,OsMASignalPeriod,OsMAPrice,MODE_MAIN,i+1);
    SignalCurrent=iMACD(NULL,0,MACDFastPeriod,MACDSlowPeriod,OsMASignalPeriod,OsMAPrice,MODE_SIGNAL,i);
    SignalPrevious=iMACD(NULL,0,MACDFastPeriod,MACDSlowPeriod,OsMASignalPeriod,OsMAPrice,MODE_SIGNAL,i+1);
    
    AC1=iOsMA(NULL,0,OsMAFastPeriod,OsMASlowPeriod,OsMASignalPeriod,OsMAPrice,i);
    AC2=iOsMA(NULL,0,OsMAFastPeriod,OsMASlowPeriod,OsMASignalPeriod,OsMAPrice,i+1);
    AC3=iOsMA(NULL,0,OsMAFastPeriod,OsMASlowPeriod,OsMASignalPeriod,OsMAPrice,i+2);
    AC4=iOsMA(NULL,0,OsMAFastPeriod,OsMASlowPeriod,OsMASignalPeriod,OsMAPrice,i+3);
    AC5=iOsMA(NULL,0,OsMAFastPeriod,OsMASlowPeriod,OsMASignalPeriod,OsMAPrice,i+4);
    

      
      if(MacdCurrent>0 || !CheckZero){
         if(After0CrosBarCnt[i]<0)After0CrosBarCnt[i]=0;
            After0CrosBarCnt[i]++;
               if(After0CrosBarCnt[i]<WhaitForBars || !CheckZero){
                  if(MacdCurrent>SignalCurrent || !CheckSignal){
                     if(Pattern_1){
                        if(AC4>0 && AC3>0 && AC2>0 && AC1>0 && AC4>AC3 && AC3<AC2 && AC2<AC1){
                           ExtMapBuffer1[i]=Low[i]-Point*5;
                        }      
                     }
                     if(Pattern_2){
                        if(AC5<0 && AC4<0 && AC3<0 && AC2<0 && AC1<0 && AC5>AC4 && AC4<AC3 && AC3<AC2 && AC2<AC1){
                           ExtMapBuffer1[i]=Low[i]-Point*5;
                        }
                     }
                     if(Pattern_3){
                        if(AC4<0 && AC3<0 && AC2<0 && AC1>0 && AC4>AC3 && AC3<AC2 && AC2<AC1){
                           ExtMapBuffer1[i]=Low[i]-Point*5;
                        }      
                     }
                  }
               }
      }
      
      if(MacdCurrent<0 || !CheckZero){  
         if(After0CrosBarCnt[i]>0)After0CrosBarCnt[i]=0;
            After0CrosBarCnt[i]--;
               if(After0CrosBarCnt[i]>-WhaitForBars || !CheckZero){   
                  if(MacdCurrent<SignalCurrent || !CheckSignal){
                     if(Pattern_1){
                        if(AC5>0 && AC4>0 && AC3>0 && AC2>0 && AC1>0 && AC5<AC4 && AC4>AC3 && AC3>AC2 && AC2>AC1){
                           ExtMapBuffer2[i]=High[i]+Point*5;
                        }
                     }
                     if(Pattern_2){
                        if(AC4<0 && AC3<0 && AC2<0 && AC1<0 && AC4<AC3 && AC3>AC2 && AC2>AC1){
                           ExtMapBuffer2[i]=High[i]+Point*5;
                        } 
                     }
                     if(Pattern_3){
                        if(AC4>0 && AC3>0 && AC2>0 && AC1<0 && AC4<AC3 && AC3>AC2 && AC2>AC1){
                           ExtMapBuffer2[i]=High[i]+Point*5;
                        }             
                     }          
                  }
               }
      }
      
        
//    if(MacdCurrent<0 && MacdCurrent<SignalCurrent
//       && MacdPrevious>SignalPrevious)
//       ExtMapBuffer2[i]=Low[i]-15*Point;
//    if(MacdCurrent<0 && MacdPrevious>0)
//       ExtMapBuffer2[i]=Low[i]-15*Point;
       
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+